<template>

    <div>
        <div v-if="editNow" class="item-list form">
            <div class="ico">
                <i class="fas fa-check"></i>
            </div>
            <div class="info">
                <div class="form">
                    <item-input :labelForm="'Название'" v-model="task.name" ></item-input>
                    <item-input :labelForm="'Изображение'" v-model="task.image" ></item-input>
                </div>
                <div class="bottom-info">
                    <div class="created"><i class="far fa-calendar-alt"></i> {{task.time | moment("DD.MM.YYYY, H:MM ") }}</div>
                    <div class="edited" v-if="task.edited.state">
                        Изменено <span>{{task.edited.time | moment("DD.MM.YYYY, H:mm")  }} </span>
                    </div>
                </div>
            </div>
            <div class="actions">
                <div class="btn btn-primary" @click="updateTask"><i class="fas fa-check"></i></div>
                <div class="btn btn-danger" @click="cancelEdit(task)"><i class="fas fa-times"></i></div>
            </div>
        </div>
        <div v-else class="item-list" :class="{'done':task.done}">
            <div class="ico" @click="doneTask(task)">
                <i class="fas fa-check"></i>
            </div>
            <div class="info">
                <div class="name">{{task.name}}</div>
                <div class="image" v-if="task.image.length > 0" >
                    <img :src="task.image" alt="" />
                </div>
                <div class="bottom-info">
                    <div class="created"><i class="far fa-calendar-alt"></i> {{task.time | moment("DD.MM.YYYY, H:mm")  }}</div>
                    <div class="edited" v-if="task.edited.state">
                        Изменено <span>{{task.edited.time | moment("DD.MM.YYYY, H:mm")  }} </span>
                    </div>
                </div>
            </div>
            <div class="actions">
                <div class="btn btn-info" @click="startEdit(task)"><i class="far fa-edit"></i></div>
                <div class="btn btn-danger" @click="deleteTask(task)"><i class="far fa-trash-alt"></i></div>

                <div class="btn btn-default" @click="likedTask">
                    <i v-if="task.liked" class="fas fa-heart"></i>
                    <i v-else class="far fa-heart"></i>
                </div>
            </div>
        </div>
    </div>


</template>

<script>
    import itemInput from '@/components/formInput'

    export default {
        name: "todoListItem",
        components: {
            itemInput
        },
        props: {
            task: {
                required: true,
                type: Object
            },
        },
        data() {
            return {
                editNow: false,
            }
        },
        methods: {
            doneTask() {
                this.task.done = !this.task.done;
            },
            deleteTask(task) {
                this.$emit("delete-task", task);
            },
            updateTask() {
                this.task.edited.state = true;
                this.task.edited.time = Date.now();
                this.editNow = false;
                this.$emit('update-list');
            },
            likedTask() {
                this.task.liked = !this.task.liked;
                this.$emit('update-list');
            },
            cancelEdit(task) {
                Object.assign(task, this._beforeEditingCache);
                this.editing = this._beforeEditingCache = null;
                this.editNow = false;

            },
            startEdit(task) {
                this._beforeEditingCache = Object.assign({}, task);
                this.editing = task;
                this.editNow = true;
            },
        }
    }
</script>

<style lang="scss" scoped>

    .item-list {
        margin: 0 0 -1px ;
        padding: 15px;
        border: 1px solid #cecece;
        display: flex;
        align-items: flex-start;

        .ico {
            min-width: 50px;
            max-width: 50px;
            height: 50px;
            margin-right: 20px;
            border: 1px solid #cecece;
            color: #cecece;
            border-radius: 50%;
            display: flex;
            align-items: center;
            justify-content: center;
            font-size: 24px;
            cursor: pointer;
        }

        .info {
            width: 100%;

            .form {
                display: flex;
                margin-bottom: 15px;
            }

            .image {
                margin: -5px 0 15px;
                text-decoration: underline;
                color: #0a34b1;
                display: block;
                width: 100%;

                img {
                    max-width: 100%;
                }
            }
            .name {
                font-size: 16px;
                font-weight: 600;
                margin-bottom: 10px;
                line-height: 20px;
            }
            .bottom-info {
                display: flex;
                align-items: center;
                width: 100%;

                .edited {
                    color: #a5a5a5;
                    font-style: italic;
                    margin-left: auto;
                }
            }

        }
        .actions {
            min-width: 85px;
            max-width: 85px;
            margin-left: 10px;
            text-align: center;

            .btn {
                margin: 2px 1px;
                width: 35px;

                &:hover {
                    opacity: 1;
                }

                &.btn-info {
                    padding-left: 12px !important;
                }
            }
        }

        &.done {

            .ico {
                border-color: #158615;
                color: #158615;
            }
            .info {
                opacity: .3;
            }
        }
    }
</style>